<template>
  <div>
    <base-dialog :show="!!error" title="An error occurred!" @close="handleError">
      <p>{{ error }}</p>
    </base-dialog>
    <section>
      <coach-filter @change-filter="setFilters"></coach-filter>
    </section>
    <section>
      <base-card>
        <div class="controls  mb-3">
          <base-button mode="outline" @click="loadCoaches(true)">Rafraîchir</base-button>
           <router-link  v-if="!isCoach && !isLoading" link to="/register" class="btn btn-outline-dark">Ajouter un prestataire</router-link>
        </div>
        <div v-if="isLoading">
          <base-spinner></base-spinner>
        </div>
        <ul v-else-if="hasCoaches">
          <coach-item
            v-for="coach in filteredCoaches"
            :key="coach.id"
            :id="coach.id"
            :firstname="coach.firstname"
            :lastname="coach.lastname"
            :email="coach.email"
            :localisation="coach.localisation"
            :created-at="coach.createdAt"
            :username="coach.username"
          ></coach-item>
        </ul>
        <h3 v-else class="text-center">Aucun prestataire n'as été trouvé.</h3>
      </base-card>
    </section>
  </div>
</template>

<script>
import CoachItem from '../../components/coaches/CoachItem.vue';
import CoachFilter from '../../components/coaches/CoachFilter.vue';

export default {
  components: {
    CoachItem,
    CoachFilter,
  },
  data() {
    return {
      isLoading: false,
      error: null,
      activeFilters: {
        frontend: true,
        backend: true,
        career: true,
      },
    };
  },
  computed: {
    isCoach() {
      return this.$store.getters['coaches/isCoach'];
    },
    filteredCoaches() {
      const coaches = this.$store.getters['coaches/coaches'];
      return coaches.filter((coach) => {
        // if (this.activeFilters.frontend && coach.areas.includes('frontend')) {
        //   return true;
        // }
        // if (this.activeFilters.backend && coach.areas.includes('backend')) {
        //   return true;
        // }
        // if (this.activeFilters.career && coach.areas.includes('career')) {
        //   return true;
        // }
        return true;
      });
    },
    hasCoaches() {
      return !this.isLoading && this.$store.getters['coaches/hasCoaches'];
    },
  },
  created() {
    this.loadCoaches();
  },
  methods: {
    setFilters(updatedFilters) {
      this.activeFilters = updatedFilters;
    },
    async loadCoaches(refresh = false) {
      this.isLoading = true;
      try {
        await this.$store.dispatch('coaches/loadCoaches', {
          forceRefresh: refresh,
        });
         console.log('ok')
      } catch (error) {
        console.log("error ", error)
        this.error = error.message || 'Something went wrong!';
      }
      this.isLoading = false;
    },
    handleError() {
      this.error = null;
    },
  },
};
</script>

<style scoped>
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.controls {
  display: flex;
  justify-content: space-between;
}
</style>